#!/usr/bin/env python

class C:
    def __init__(self):
        self.visitor = self

    def default(self, node):
        return 123

    def dispatch(self, node):
        try:
            return node.visit(self.visitor)
        except AttributeError:
            return self.visitor.default(node)

class N:
    def visit(self, visitor):
        return 456

c = C()
n = N()
result_456 = c.dispatch(n)

# vim: tabstop=4 expandtab shiftwidth=4
